<?php

// Den direkten Aufruf verbieten
defined('_JEXEC') or die;

/**
 * NoesisDb component helper.
 */
abstract class NoesisDbHelper
{
	/**
	 * Configure the Linkbar.
	 */
	public static function addSubmenu($submenu)
	{
		JSubMenuHelper::addEntry(
			JText::_('COM_NOESISDB_SUBMENU_TEACHERS'),
			'index.php?option=com_noesisdb&view=teachers',
			$submenu == 'teacher');

		JSubMenuHelper::addEntry(
			JText::_('COM_NOESISDB_SUBMENU_DISCIPLINES'),
			'index.php?option=com_noesisdb&view=disciplines',
			$submenu == 'discipline');

		JSubMenuHelper::addEntry(
			JText::_('COM_NOESISDB_SUBMENU_DEPARTMENTS'),
			'index.php?option=com_noesisdb&view=departments',
			$submenu == 'department');

		$document = JFactory::getDocument();
		$document->addStyleDeclaration(
			'.icon-noesisdb '
				. '{background-image: url(../media/com_noesisdb/images/database-16x16.png) !important;}');
		if ($submenu == 'teacher')
		{
			$document->setTitle(JText::_('COM_NOESISDB_ADMINISTRATION_TEACHERS'));
		}
		if ($submenu == 'disciplines')
		{
			$document->setTitle(JText::_('COM_NOESISDB_ADMINISTRATION_DISCIPLINES'));
		}
		if ($submenu == 'departments')
		{
			$document->setTitle(JText::_('COM_NOESISDB_ADMINISTRATION_DEPARTMENTS'));
		}
	}

	/**
	 * Get the actions
	 */
	public static function getActions($entryId = 0)
	{
		$user = JFactory::getUser();
		$result = new JObject;

		$view = JRequest::getVar('view');
		$view = empty($view) ? 'teacher' : $view;

		if (empty($entryId))
		{
			$assetName = 'com_noesisdb';
		}
		else
		{
			if (strpos($view, 'teacher') === 0)
				$assetName = 'com_noesisdb.teacher.' . (int) $entryId;
			if (strpos($view, 'discipline') === 0)
				$assetName = 'com_noesisdb.discipline.' . (int) $entryId;
			if (strpos($view, 'department') === 0)
				$assetName = 'com_noesisdb.department.' . (int) $entryId;
		}

		$actions = array('core.admin', 'core.manage', 'core.create'
		, 'core.edit', 'core.delete');

		foreach ($actions as $action)
		{
			$result->set($action, $user->authorise($action, $assetName));
		}

		return $result;
	}
}
