<?php

// Den direkten Aufruf verbieten
defined('_JEXEC') or die;

// Die Joomla! Modellist Klasse importieren
jimport('joomla.application.component.modellist');

/**
 * Departments Model
 */
class NoesisDbModelDepartments extends JModelList
{
	/**
	 * Method to build an SQL query to load the list data.
	 * Funktion um einen SQL Query zu erstellen der die Daten für die Liste läd.
	 *
	 * @return string SQL query
	 */
	protected function getListQuery()
	{
		// Ein Datenbankobjekt beziehen.
		$db = JFactory::getDBO();

		// Ein neues (leeres) Queryobjekt beziehen.
		$query = $db->getQuery(true);

		// Aus der Tabelle 'noesisdb_departments'...
		$query->from('#__noesisdb_departments');

		// ... Felder auswählen.
		$query->select('*');

		return $query;
	}

	protected function canDelete($record)
	{
		$user = JFactory::getUser();
		return $user->authorise('core.delete', $this->option);
	}

	function delete($ids = array()) {

		// Ein neues (leeres) Queryobjekt beziehen.
		$db = JFactory::getDBO();

		// Prüfen, ob gelöscht werden kann
		$errMsg = '';
		foreach($ids as $k=>$id) {
			// Aus der Tabelle 'noesisdb_departments'...
			$query = $db->getQuery(true);
			$query->from('#__noesisdb_departments');
			// ... Felder auswählen.
			$query->select($db->quoteName('department').','.$db->quoteName('shortcut'));
			$conditions = array(
		    $db->quoteName('id').' = '.$id
			);
			$query->where($conditions);
			$db->setQuery($query);
			$db->execute();
			$shortcut = $db->loadObject()->shortcut;
			$department = $db->loadObject()->department;
			// Aus der Tabelle 'noesisdb_disciplines'...
			$query = $db->getQuery(true);
			$query->from('#__noesisdb_disciplines');
			// ... Felder auswählen.
			$query->select($db->quoteName('discipline'));
			$conditions = array(
		    $db->quoteName('department').' = "'.$shortcut.'"'
			);
			$query->where($conditions);
			$db->setQuery($query);
			$db->execute();
			$errMsg1 = '';
			while (($o = $db->loadNextObject()) !== false)
				$errMsg1 .= $o->discipline.', ';
			if (!empty($errMsg1)) {
				if (strpos($errMsg1, ',') != strrpos($errMsg1, ','))
					$errMsg1 = 'Fachbereich <b>'.$department.'</b> kann nicht gelöscht werden, weil folgende Fächer zugeordnet sind: <i>'.substr($errMsg1, 0, strlen($errMsg1)-2);
				else
					$errMsg1 = 'Fachbereich <b>'.$department.'</b> kann nicht gelöscht werden, weil folgendes Fach zugeordnet ist: <i>'.substr($errMsg1, 0, strlen($errMsg1)-2);
				$errMsg .= '<li>'.$errMsg1.'</li>';
			}
		}
		if (!empty($errMsg)) {
			$this->setError('<ul>'.$errMsg.'</ul>');
			return false;
		}

		$idStr = '';
		if (count($ids))
			$idStr = implode(',', $ids);

		$conditions = array(
		  $db->quoteName('id').' IN ('.$idStr.')'
		);

		$query = $db->getQuery(true);
		$query->delete($db->quoteName('#__noesisdb_departments'));
		$query->where($conditions);
		$db->setQuery($query);
		$result = $db->execute();

		// Clear the component's cache
		$this->cleanCache();

		return true;
	}
}
