<?php

// Den direkten Aufruf verbieten
defined('_JEXEC') or die;

// Die Joomla! Modellist Klasse importieren
jimport('joomla.application.component.modellist');

/**
 * Disciplines Model
 */
class NoesisDbModelDisciplines extends JModelList
{
	/**
	 * Method to build an SQL query to load the list data.
	 * Funktion um einen SQL Query zu erstellen der die Daten für die Liste läd.
	 *
	 * @return string SQL query
	 */
	protected function getListQuery()
	{
		// Ein Datenbankobjekt beziehen.
		$db = JFactory::getDBO();

		// Ein neues (leeres) Queryobjekt beziehen.
		$query = $db->getQuery(true);

		// Aus der Tabelle 'noesisdb_teachers'...
		$query->from('#__noesisdb_disciplines');

		// ... Felder auswählen.
		$query->select('*');

		return $query;
	}

	protected function canDelete($record)
	{
		$user = JFactory::getUser();
		return $user->authorise('core.delete', $this->option);
	}

	function delete($ids = array()) {

		// Ein neues (leeres) Queryobjekt beziehen.
		$db = JFactory::getDBO();

		// Prüfen, ob gelöscht werden kann
		$errMsg = '';
		foreach($ids as $k=>$id) {
			// Aus der Tabelle 'noesisdb_disciplines'...
			$query = $db->getQuery(true);
			$query->from('#__noesisdb_disciplines');
			// ... Felder auswählen.
			$query->select($db->quoteName('discipline').','.$db->quoteName('shortcut'));
			$conditions = array(
		    $db->quoteName('id').' = '.$id
			);
			$query->where($conditions);
			$db->setQuery($query);
			$db->execute();
			$shortcut = $db->loadObject()->shortcut;
			$discipline = $db->loadObject()->discipline;
			// Aus der Tabelle 'noesisdb_teachers'...
			$query = $db->getQuery(true);
			$query->from('#__noesisdb_teachers');
			// ... Felder auswählen.
			$query->select($db->quoteName('surname').','.$db->quoteName('title').','.$db->quoteName('gender').','.$db->quoteName('shortcut'));
			$conditions = array(
		    $db->quoteName('discipline1').' = "'.$shortcut.'"',
		    $db->quoteName('discipline2').' = "'.$shortcut.'"',
		    $db->quoteName('discipline3').' = "'.$shortcut.'"',
		    $db->quoteName('discipline4').' = "'.$shortcut.'"'
			);
			$query->where($conditions, 'OR');
			$db->setQuery($query);
			$db->execute();
			$errMsg1 = '';
			while (($o = $db->loadNextObject()) !== false) {
				$nameStr = ($o->gender == 'm') ? '<b>Herr ' : '<b>Frau ';
				$nameStr .= $o->title.' '.$o->surname.'</b>';
				$errMsg1 .= $nameStr.', ';
			}
			if (!empty($errMsg1)) {
				if (strpos($errMsg1, ',') != strrpos($errMsg1, ','))
					$errMsg1 = 'Fach <b>'.$discipline.'</b> kann nicht gelöscht werden, weil folgende Lehrerinnen bzw. Lehrer zugeordnet sind: '.substr($errMsg1, 0, strlen($errMsg1)-2);
				else
					$errMsg1 = 'Fach <b>'.$discipline.'</b> kann nicht gelöscht werden, weil folgende Lehrerin bzw. folgender Lehrer zugeordnet ist: '.substr($errMsg1, 0, strlen($errMsg1)-2);
				$errMsg .= '<li>'.$errMsg1.'</li>';
			}
		}
		if (!empty($errMsg)) {
			$this->setError('<ul>'.$errMsg.'</ul>');
			return false;
		}

		$idStr = '';
		if (count($ids))
			$idStr = implode(',', $ids);

		$conditions = array(
		  $db->quoteName('id').' IN ('.$idStr.')'
		);

		$query = $db->getQuery(true);
		$query->delete($db->quoteName('#__noesisdb_departments'));
		$query->where($conditions);
		$db->setQuery($query);
		$result = $db->execute();

		// Clear the component's cache
		$this->cleanCache();

		return true;
	}
}
