<?php

// Den direkten Aufruf verbieten
defined('_JEXEC') or die;

// Die Joomla! Form Helper Bibliothek importieren
jimport('joomla.form.helper');

JFormHelper::loadFieldClass('list');

/**
 * NoesisDb     Form Field class for the NoesisDb component
 */
class JFormFieldDepartmentList extends JFormFieldList
{
	/**
	 * The field type.
	 *
	 * @var         string
	 */
	protected $type = 'DepartmentList';

	/**
	 * Method to get a list of options for a list input.
	 *
	 * @return      array           An array of JHtml options.
	 */
	protected function getOptions()
	{
		$db = JFactory::getDBO();

		$query = $db->getQuery(true);

		$query->from('#__noesisdb_departments AS t');
		$query->select('t.shortcut, t.department');
		$query->order('t.department');

		$db->setQuery((string) $query);

		$departments = $db->loadObjectList();

		$options = array();

		foreach ($departments as $department)
		{
			$options[] = JHtml::_('select.option', $department->shortcut,
														$department->department);
		}


		$options = array_merge(parent::getOptions(), $options);

		return $options;
	}
}
