<?php

// Den direkten Aufruf verbieten
defined('_JEXEC') or die;

// Die Joomla! Form Helper Bibliothek importieren
jimport('joomla.form.helper');

JFormHelper::loadFieldClass('list');

/**
 * NoesisDb     Form Field class for the NoesisDb component
 */
class JFormFieldDisciplineList extends JFormFieldList
{
	/**
	 * The field type.
	 *
	 * @var         string
	 */
	protected $type = 'DisciplineList';

	/**
	 * Method to get a list of options for a list input.
	 *
	 * @return      array           An array of JHtml options.
	 */
	protected function getOptions()
	{
		$db = JFactory::getDBO();

		$query = $db->getQuery(true);

		$query->from('#__noesisdb_disciplines AS d');
		$query->select('d.shortcut, d.discipline');
		$query->order('d.discipline');

		$db->setQuery((string) $query);

		$disciplines = $db->loadObjectList();

		$options = array();

		if (!$disciplines) {
			// some standard entries
			$options[] = JHtml::_('select.option', 'Bio', 'Biologie');
			$options[] = JHtml::_('select.option', 'Ma', 'Mathematik');
			$options[] = JHtml::_('select.option', 'Phy', 'Physik');
			$options[] = JHtml::_('select.option', 'Ch', 'Chemie');
		}

		foreach ($disciplines as $discipline)
		{
			$options[] = JHtml::_('select.option', $discipline->shortcut,
														$discipline->discipline);
		}


		$options = array_merge(parent::getOptions(), $options);

		return $options;
	}
}
