<?php

// Den direkten Aufruf verbieten
defined('_JEXEC') or die;

// Die Joomla! Form Helper Bibliothek importieren
jimport('joomla.form.helper');

JFormHelper::loadFieldClass('list');

/**
 * NoesisDb     Form Field class for the NoesisDb component
 */
class JFormFieldTeacherList extends JFormFieldList
{
	/**
	 * The field type.
	 *
	 * @var         string
	 */
	protected $type = 'TeacherList';

	/**
	 * Method to get a list of options for a list input.
	 *
	 * @return      array           An array of JHtml options.
	 */
	protected function getOptions()
	{
		$db = JFactory::getDBO();

		$query = $db->getQuery(true);

		$query->from('#__noesisdb_teachers AS t');
		$query->select('t.shortcut, t.surname, t.firstname');
		$query->order('t.surname, t.firstname');

		$db->setQuery((string) $query);

		$teachers = $db->loadObjectList();

		$options = array();

		foreach ($teachers as $teacher)
		{
			$options[] = JHtml::_('select.option', $teacher->shortcut,
														$teacher->surname.', '.$teacher->firstname);
		}


		$options = array_merge(parent::getOptions(), $options);

		return $options;
	}
}
