<?php

// Den direkten Aufruf verbieten
defined('_JEXEC') or die;

// Die Joomla! Modellist Klasse importieren
jimport('joomla.application.component.modellist');

/**
 * Teachers Model
 */
class NoesisDbModelTeachers extends JModelList
{
	/**
	 * Method to build an SQL query to load the list data.
	 * Funktion um einen SQL Query zu erstellen der die Daten für die Liste läd.
	 *
	 * @return string SQL query
	 */
	protected function getListQuery()
	{
		// Ein Datenbankobjekt beziehen.
		$db = JFactory::getDBO();

		// Ein neues (leeres) Queryobjekt beziehen.
		$query = $db->getQuery(true);

		// Aus der Tabelle 'noesisdb_teachers'...
		$query->from('#__noesisdb_teachers');

		// ... Felder auswählen.
		$query->select('*');
		$query->order('shortcut');

		return $query;
	}

	protected function canDelete($record)
	{
		$user = JFactory::getUser();
		return $user->authorise('core.delete', $this->option);
	}

	function delete($ids = array()) {

		$db = JFactory::getDBO();

		// Prüfen, ob Zuordnungen bestehen
		$errMsg = '';
		foreach($ids as $k=>$id) {
			// Aus der Tabelle 'noesisdb_teachers'...
			$query = $db->getQuery(true);
			$query->from('#__noesisdb_teachers');
			// ... Felder auswählen.
			$query->select($db->quoteName('surname').','.$db->quoteName('title').','.$db->quoteName('gender').','.$db->quoteName('shortcut'));
			$conditions = array(
		    $db->quoteName('id').' = '.$id
			);
			$query->where($conditions);
			$db->setQuery($query);
			$db->execute();
			$shortcut = $db->loadObject()->shortcut;
			$surname = $db->loadObject()->surname;
			$title = $db->loadObject()->title;
			$gender = $db->loadObject()->gender;

			$nameStr = ($gender == 'm') ? '<b>Herr ' : '<b>Frau ';
			$nameStr .= $title.' '.$surname.'</b> ist noch eingetragen ';
			$genderStr = ($gender == 'm') ? '' : 'in';

			// Aus der Tabelle 'noesisdb_disciplines'...
			$query = $db->getQuery(true);
			$query->from('#__noesisdb_disciplines');
			$query->select($db->quoteName('discipline'));
			$conditions = array(
		    $db->quoteName('discipline_leader').' = "'.$shortcut.'"'
			);
			$query->where($conditions);
			$db->setQuery($query);
			$db->execute();
			$errMsg1 = '';
			while (($o = $db->loadNextObject()) !== false) {
				$errMsg1 .= $o->discipline.', ';
			}
			if (!empty($errMsg1)) {
				$errMsg1 = 'als Fachleiter'.$genderStr.' für '.substr($errMsg1, 0, strlen($errMsg1)-2);
			}

			// Aus der Tabelle 'noesisdb_departments'...
			$query = $db->getQuery(true);
			$query->from('#__noesisdb_departments');
			$query->select($db->quoteName('department'));
			$conditions = array(
		    $db->quoteName('supervisor').' = "'.$shortcut.'"'
			);
			$query->where($conditions);
			$db->setQuery($query);
			$db->execute();
			$errMsg2 = '';
			while (($o = $db->loadNextObject()) !== false) {
				$errMsg2 .= $o->department.', ';
			}
			if (!empty($errMsg2)) {
				if (!empty($errMsg1))
					$errMsg2 .= ' und ';
				$errMsg2 = 'als Fachbereichsleiter'.$genderStr.' für '.substr($errMsg2, 0, strlen($errMsg2)-2);
			}

			if (!empty($errMsg1) || !empty($errMsg2)) {
				$errMsg .= '<li>'.$nameStr.$errMsg1.$errMsg2.'.</li>';
			}
		}
		if (!empty($errMsg)) {
      $this->setError('<ul>'.$errMsg.'</ul>');
			return false;
		}

		// Ein neues (leeres) Queryobjekt beziehen.
		$query = $db->getQuery(true);

		$idStr = '';
		if (count($ids))
			$idStr = implode(',', $ids);

		$conditions = array(
	    $db->quoteName('id').' IN ('.$idStr.')'
		);

		$query->delete($db->quoteName('#__noesisdb_teachers'));
		$query->where($conditions);
		$db->setQuery($query);
		$result = $db->execute();

		// Clear the component's cache
		$this->cleanCache();

		return true;
	}
}
