CREATE TABLE IF NOT EXISTS `#__noesisdb_departments` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `shortcut` varchar(10) NOT NULL COMMENT 'Kürzel',
  `department` varchar(25) DEFAULT NULL COMMENT 'Fachbereichsname',
  `supervisor` varchar(5) DEFAULT NULL COMMENT 'Fachbereichsleiter',
  `ordered` tinyint(1) NOT NULL DEFAULT 0 COMMENT 'beauftragt',
  `supervisor2` varchar(5) DEFAULT NULL COMMENT 'Fachbereichsleiter 2',
  `ordered2` tinyint(1) NOT NULL DEFAULT 0 COMMENT 'beauftragt 2',
  PRIMARY KEY (`id`),
  UNIQUE KEY `shortcut` (`shortcut`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 DEFAULT COLLATE=utf8_unicode_ci COMMENT='Fachbereiche';

CREATE TABLE IF NOT EXISTS `#__noesisdb_disciplines` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `shortcut` varchar(10) NOT NULL COMMENT 'Kürzel',
  `discipline` varchar(25) NOT NULL COMMENT 'Fach',
  `link_curriculum_1` varchar(200) DEFAULT NULL COMMENT 'Lehrplan Sekundarstufe 1',
  `link_curriculum_2` varchar(200) DEFAULT NULL COMMENT 'Lehrplan Sekundarstufe 2',
  `discipline_leader` varchar(5) DEFAULT NULL COMMENT 'Fachleiter',
  `ordered` tinyint(1) NOT NULL DEFAULT 0 COMMENT 'beauftragt',
  `discipline_leader2` varchar(5) DEFAULT NULL COMMENT 'Fachleiter 2',
  `ordered2` tinyint(1) NOT NULL DEFAULT 0 COMMENT 'beauftragt 2',
  `department` varchar(5) DEFAULT NULL COMMENT 'Fachbereich',
  PRIMARY KEY (`id`),
  UNIQUE KEY `shortcut` (`shortcut`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 DEFAULT COLLATE=utf8_unicode_ci COMMENT='Fächer';

CREATE TABLE IF NOT EXISTS `#__noesisdb_teachers` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `shortcut` varchar(5) NOT NULL COMMENT 'Kürzel',
  `surname` varchar(50) NOT NULL COMMENT 'Nachname',
  `firstname` varchar(25) NOT NULL COMMENT 'Vorname',
  `title` varchar(10) DEFAULT NULL COMMENT 'Titel',
  `gender` set('-','m','w') NOT NULL DEFAULT '-' COMMENT 'Geschlecht',
  `email` varchar(100) NOT NULL COMMENT 'E-Mail',
  `func` varchar(25) NOT NULL COMMENT 'Funktion',
  `discipline1` varchar(10) NOT NULL COMMENT 'Fach 1',
  `discipline2` varchar(10) DEFAULT NULL COMMENT 'Fach 2',
  `discipline3` varchar(10) DEFAULT NULL COMMENT 'Fach 3',
  `discipline4` varchar(10) DEFAULT NULL COMMENT 'Fach 4',
  PRIMARY KEY (`id`),
  UNIQUE KEY `shortcut` (`shortcut`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 DEFAULT COLLATE=utf8_bin COMMENT='Lehrer';
