<?php

// Den direkten Aufruf verbieten
defined('_JEXEC') or die;

// Die Joomla! View Bibliothek importieren
jimport('joomla.application.component.view');

/**
 * Departments HTML View
 */
class NoesisDbViewDepartments extends JViewLegacy
{
	/**
	 * @var array
	 */
	protected $items = array();

	/**
	 * @var JPagination
	 */
	protected $pagination;

	/**
	 * Departments view display method
	 *
	 * @param null $tpl
	 *
	 * @return void
	 */
	function display($tpl = null)
	{
		// Die Daten werden vom Model bezogen
		$this->items = $this->get('Items');

		// Ein JPagination Objekt beziehen
		$this->pagination = $this->get('Pagination');

		// Die Toolbar hinzufügen
		$this->addToolBar();

		// Das Template wird aufgerufen
		parent::display($tpl);

		// Set the document
		$this->setDocument();
	}

	/**
	 * Setting the toolbar
	 */
	protected function addToolBar()
	{
		$canDo = NoesisDbHelper::getActions();

		JToolBarHelper::title(JText::_('COM_NOESISDB_MANAGER_DEPARTMENTS'), 'noesisdb');

		if ($canDo->get('core.create'))
		{
			JToolBarHelper::addNew('department.add');
		}

		if ($canDo->get('core.edit'))
		{
			JToolBarHelper::editList('department.edit');
		}

		if ($canDo->get('core.delete'))
		{
			JToolBarHelper::deleteList('', 'departments.delete');
		}

		if ($canDo->get('core.admin'))
		{
			JToolBarHelper::divider();
			JToolBarHelper::preferences('com_noesisdb');
		}

		// CSS Klasse für das 48x48 Icon der Toolbar
		JFactory::getDocument()->addStyleDeclaration(
			'.icon-noesisdb {background-image: url(../media/com_noesisdb/images/database-16x16.png);}'
		);
	}

	/**
	 * Method to set up the document properties
	 *
	 * @return void
	 */
	protected function setDocument()
	{
		JFactory::getDocument()
			->setTitle(JText::_('COM_NOESISDB_ADMINISTRATION'));
	}
}
