<?php

// Den direkten Aufruf verbieten
defined('_JEXEC') or die;

/**
 * Teacher View
 */
class NoesisDbViewDiscipline extends JViewLegacy
{
	/**
	 * Display method of Teacher view.
	 *
	 * @return void
	 */
	public function display($tpl = null)
	{
		// Die Daten werden bezogen
		$this->item = $this->get('Item');

		// Das Formular
		$this->form = $this->get('Form');

		// JavaScript
		$this->script = $this->get('Script');

		// Die Toolbar hinzufügen
		$this->addToolBar();

		// Das Template wird aufgerufen
		parent::display($tpl);

		// Set the document
		$this->setDocument();
	}

	/**
	 * Setting the toolbar
	 */
	protected function addToolBar()
	{
		JRequest::setVar('hidemainmenu', true);

		$canDo = NoesisDbHelper::getActions($this->item->id);
		$isNew = $this->item->id == 0;

		JToolBarHelper::title(
			$isNew
				? JText::_('COM_NOESISDB_MANAGER_DISCIPLINES_NEW')
				: JText::_('COM_NOESISDB_MANAGER_DISCIPLINES_EDIT'),
			'noesisdb');

		// Built the actions for new and existing records.
		if ($isNew)
		{
			// For new records, check the create permission.
			if ($canDo->get('core.create'))
			{
				JToolBarHelper::apply('discipline.apply', 'JTOOLBAR_APPLY');
				JToolBarHelper::save('discipline.save', 'JTOOLBAR_SAVE');
				JToolBarHelper::custom('discipline.save2new', 'save-new.png', 'save-new_f2.png', 'JTOOLBAR_SAVE_AND_NEW', false);
			}

			JToolBarHelper::cancel('discipline.cancel', 'JTOOLBAR_CANCEL');
		}
		else
		{
			if ($canDo->get('core.edit'))
			{
				// We can save the new record
				JToolBarHelper::apply('discipline.apply', 'JTOOLBAR_APPLY');
				JToolBarHelper::save('discipline.save');

				// We can save this record, but check the create permission to see if we can return to make a new one.
				if ($canDo->get('core.create'))
				{
					JToolBarHelper::custom('discipline.save2new', 'save-new.png', 'save-new_f2.png', 'JTOOLBAR_SAVE_AND_NEW', false);
				}
			}

			if ($canDo->get('core.create'))
			{
				JToolBarHelper::custom('discipline.save2copy', 'save-copy.png', 'save-copy_f2.png', 'JTOOLBAR_SAVE_AS_COPY', false);
			}

			JToolBarHelper::cancel('discipline.cancel', 'JTOOLBAR_CLOSE');
		}

		// CSS Klasse für das 48x48 Icon der Toolbar
		JFactory::getDocument()->addStyleDeclaration(
			'.icon-noesisdb {background-image: url(../media/com_noesisdb/images/database-16x16.png);}'
		);
	}

	/**
	 * Method to set up the document properties
	 *
	 * @return void
	 */
	protected function setDocument()
	{
		$isNew = ($this->item->id < 1);

		$document = JFactory::getDocument();

		$document->setTitle(
			$isNew
				? JText::_('COM_NOESISDB_DISCIPLINES_CREATING')
				: JText::_('COM_NOESISDB_DISCIPLINES_EDITING')
		);

		$document->addScript(JURI::root(true) . $this->script);

		$document->addScript(
			JURI::root(true)
				. '/administrator/components/com_noesisdb/views/discipline/submitbutton.js');

		JText::script('COM_NOESISDB_NOESISDB_ERROR_UNACCEPTABLE');
	}
}
