<?php

// Den direkten Aufruf verbieten
defined('_JEXEC') or die;

// Die Joomla! Modelitem Klasse importieren
jimport('joomla.application.component.modelitem');

/**
 * NoesisDb Frontend Model
 */
class NoesisDbModelNoesisDb extends JModelItem
{
	/**
	 * @var string msg
	 */
	protected $item;
	protected $supervisor;
	protected $supervisor2;
	protected $leader;
	protected $leader2;
	protected $teachers;
	protected $items;

	/**
	 * Get the discipline.
	 * Ein Fach aus der Datenbank beziehen.
	 *
	 * @return string The message to be displayed to the user
	 * @return string Die Nachricht die dem Benutzer angezeigt wird.
	 */
	public function getItem()
	{
		if (!isset($this->item))
		{
			$shortcut = JRequest::getVar('fach');
			if (empty($shortcut))
				$shortcut = JRequest::getVar('discipline');

			$this->_db->setQuery(
				$this->_db->getQuery(true)
				->from('#__noesisdb_disciplines as d')
				->select('d.*')
				->where('d.shortcut="'.$shortcut.'"')
			);

			if (!$this->item = $this->_db->loadObject())
			{
				$this->setError($this->_db->getError());
			}
		}

		return $this->item;
	}

	/**
	 * Get the teachers of a discipline.
	 * Lehrer für ein Fach aus der Datenbank beziehen.
	 *
	 * @return string The message to be displayed to the user
	 * @return string Die Nachricht die dem Benutzer angezeigt wird.
	 */
	public function getTeachers() {
		if (!isset($this->teachers)) {
			$shortcut = JRequest::getVar('fach');
			if (empty($shortcut))
				$shortcut = JRequest::getVar('discipline');
			$db = JFactory::getDBO();

			$query = $db->getQuery(true);

			$query->from('#__noesisdb_teachers AS t');
			$query->select('t.*');
			$query->where('t.discipline1="'.$shortcut.'" or t.discipline2="'.$shortcut.'" or t.discipline3="'.$shortcut.'" or t.discipline4="'.$shortcut.'"');
			$query->order('t.surname, t.firstname');

			$db->setQuery((string) $query);

			$this->teachers = $db->loadObjectList();

			if (!$this->teachers) {
				$this->setError($this->_db->getError());
			}
		}
		return $this->teachers;
	}

	/**
	 * Get the supervisor of a department.
	 * Fachbereichsleiter für einen Fachberech aus der Datenbank beziehen.
	 *
	 * @return string The message to be displayed to the user
	 * @return string Die Nachricht die dem Benutzer angezeigt wird.
	 */
	public function getSupervisor() {
		if (!empty($this->item->department) && !isset($this->supervisor)) {
			$this->_db->setQuery(
				$this->_db->getQuery(true)
				->from('#__noesisdb_teachers as t, #__noesisdb_departments as d')
				->select('t.*, d.shortcut as x, d.department as department_name, d.ordered')
				->where('t.shortcut=d.supervisor and d.shortcut="'.$this->item->department.'"')
			);

			$this->supervisor = $this->_db->loadObject();

			if (!$this->supervisor) {
				$this->setError($this->_db->getError());
			}
		}
		return $this->supervisor;
	}

	/**
	 * Get the supervisor (2) of a department.
	 * Fachbereichsleiter für einen Fachberech aus der Datenbank beziehen.
	 *
	 * @return string The message to be displayed to the user
	 * @return string Die Nachricht die dem Benutzer angezeigt wird.
	 */
	public function getSupervisor2() {
		if (!empty($this->item->department) && !isset($this->supervisor2)) {
			$this->_db->setQuery(
				$this->_db->getQuery(true)
				->from('#__noesisdb_teachers as t, #__noesisdb_departments as d')
				->select('t.*, d.shortcut as x, d.department as department_name, d.ordered2 as ordered')
				->where('t.shortcut=d.supervisor2 and d.shortcut="'.$this->item->department.'"')
			);

			$this->supervisor2 = $this->_db->loadObject();

			if (!$this->supervisor2) {
				$this->setError($this->_db->getError());
			}
		}
		return $this->supervisor2;
	}

	public function getLeader() {
		if (!empty($this->item->discipline_leader) && !isset($this->leader)) {
			$this->_db->setQuery(
				$this->_db->getQuery(true)
				->from('#__noesisdb_teachers as t, #__noesisdb_disciplines as d')
				->select('t.*, d.ordered')
				->where('t.shortcut="'.$this->item->discipline_leader.'" and d.shortcut="'.$this->item->shortcut.'"')
			);

			$this->leader = $this->_db->loadObject();

			if (!$this->leader) {
				$this->setError($this->_db->getError());
			}
		}
		return $this->leader;
	}

	public function getLeader2() {
		if (!empty($this->item->discipline_leader) && !isset($this->leader2)) {
			$this->_db->setQuery(
				$this->_db->getQuery(true)
				->from('#__noesisdb_teachers as t, #__noesisdb_disciplines as d')
				->select('t.*, d.ordered2 as ordered')
				->where('t.shortcut="'.$this->item->discipline_leader2.'" and d.shortcut="'.$this->item->shortcut.'"')
			);

			$this->leader2 = $this->_db->loadObject();

			if (!$this->leader2) {
				$this->setError($this->_db->getError());
			}
		}
		return $this->leader2;
	}

	public function getItems() {
		if (!isset($this->items)) {
			$this->_db->setQuery(
				$this->_db->getQuery(true)
				->from('#__noesisdb_teachers as t')
				->select('t.*')
				->order('t.surname, t.firstname')
			);

			$this->items = $this->_db->loadObjectList();

			if (!$this->items) {
				echo 'WARNUNG: Es sind keine Lehrer festgelegt';
				$this->setError($this->_db->getError());
			}
		}
		return $this->items;
	}
}
